#include "NSTableView-Images.h"

@implementation NSTableViewImages


- (void) dealloc
{
  RELEASE(data);
  [super dealloc];
}

- (id) init
{
  if( (self = [super init]) )
    {
      data = [[NSMutableArray alloc] initWithArray:
        [[NSDictionary dictionaryWithContentsOfFile: 
          [[NSBundle bundleForClass: [self class]] pathForResource: @"data" ofType: @"plist"]] 
          objectForKey: @"data"]];
      wc = [[NSWindowController alloc] initWithWindowNibName: @"Images" owner: self];
     [[wc window] makeKeyAndOrderFront: self]; 
     [tableView setAutoresizesAllColumnsToFit: YES];
    }
  return self;
}

-(void) restart
{
  [[wc window] makeKeyAndOrderFront: nil];
}

- (void) resetTable: (id) sender
{
  RELEASE(data);
  data = [[NSMutableArray alloc] initWithArray:
        [[NSDictionary dictionaryWithContentsOfFile: 
          [[NSBundle bundleForClass: [self class]] pathForResource: @"data" ofType: @"plist"]] 
          objectForKey: @"data"]];
  [tableView reloadData];
  [tableView deselectAll: self];
}

- (void) resetLog: (id) sender
{
  [textView setString: @""];
}

- (int) numberOfRowsInTableView: (NSTableView *) aTableView
{
  return [data count];
}

- (id)            tableView: (NSTableView *) aTableView
  objectValueForTableColumn: (NSTableColumn *) aTableColumn
                        row: (int) rowIndex
{
	if( [[aTableColumn identifier] isEqualToString: @"data"] )
	{
		return [[data objectAtIndex: rowIndex] objectForKey: @"left"];
	}

	if( [[aTableColumn identifier] isEqualToString: @"image"] )
	{
		if ([[[data objectAtIndex: rowIndex] objectForKey: @"right"] length] > 4)
		{
			[self _log: [NSString stringWithFormat: @"Returning an image for row %i", rowIndex]];
			return [NSImage imageNamed: @"NSApplicationIcon"];
		}
	}
    	[self _log: [NSString stringWithFormat: @"Returning nil for row %i", rowIndex]];
	return nil;
}

- (void) _log: (NSString *) theString
{
  NSMutableString *temp;

  temp = [[NSMutableString alloc] initWithString: [textView string]];
  [temp appendString: [NSString stringWithFormat: @"\n%@",theString]];
  [textView setString: temp];
  [textView scrollRangeToVisible:NSMakeRange([[textView string] length], 0)];
}

@end

    
